Kubernetes 1.20.2高可用集群快速升级及扩容

Stella981
• 阅读 370

2021年已经到来,让我们有一个新的开始。

Kubernetes 1.20.2已经正式发布,高可用集群也可以直接升级(hub.docker.com已经停更,使用registry.cn-hangzhou.aliyuncs.com/google_containers)。快速升级(含国内镜像快速下载链接)包括升级kubeadm/kubectl/kubelet版本、拉取镜像、升级Kubernetes集群三个主要步骤。参考《Ubuntu上软件锁定版本不更新》安装特定DockerCE版本。

Kubernetes 1.20.2高可用集群快速升级及扩容

提前将镜像传送到相应节点上,然后在任何一个master节点运行下面的命令即可完成升级。

kubeadm upgrade apply v1.20.2

在当前的集群中新增节点:

  • 第一步,重新创建certificate key和token:

    sudo kubeadm init phase upload-certs --upload-certs

    Got:

    [upload-certs] Using certificate key:

    2ffe5bbf7d2e670d5bcfb03dac194e2f21eb9715f2099c5f8574e4ba7679ff78

    Add certificate-key for Multi Master Node.

    kubeadm token create --print-join-command --certificate-key 2ffe5bbf7d2e670d5bcfb03dac194e2f21eb9715f2099c5f8574e4ba7679ff78

  • 第二步,增加Worker节点:

    kubeadm join 192.168.199.173:6443 --token rlxvkn.2ine1loolri50tzt --discovery-token-ca-cert-hash sha256:86e68de8febb844ab8f015f6af4526d78a980d9cdcf7863eebb05b17c24b9383

  • 第三步,增加master节点:

    kubeadm join 192.168.199.173:6443 --token rlxvkn.2ine1loolri50tzt --discovery-token-ca-cert-hash sha256:86e68de8febb844ab8f015f6af4526d78a980d9cdcf7863eebb05b17c24b9383 --control-plane --certificate-key 440a880086e7e9cbbcebbd7924e6a9562d77ee8de7e0ec63511436f2467f7dde

在arm上部署kubernetes参考:

升级时出现一些小错误,后来解决了:

1、升级kubeadm/kubectl/kubelet版本

sudo apt install kubeadm=1.20.2-00 kubectl=1.20.2-00 kubelet=1.20.2-00

查看该版本的容器镜像版本:

kubeadm config images list

输出如下:

~# kubeadm config images list

k8s.gcr.io/kube-apiserver:v1.20.2
k8s.gcr.io/kube-controller-manager:v1.20.2
k8s.gcr.io/kube-scheduler:v1.20.2
k8s.gcr.io/kube-proxy:v1.20.2
k8s.gcr.io/pause:3.2
k8s.gcr.io/etcd:3.4.13-0
k8s.gcr.io/coredns:1.7.0

2、拉取容器镜像

原始的kubernetes镜像文件在gcr上,不能直接下载。我原来是把镜像到了阿里云的杭州机房的容器仓库里,拉取还是比较快的。现在hub.docker.com的访问没有问题了,有同学把镜像放到料里面,而且更新还挺及时,可以直接用。

#mirrorgcrio已经没有更新了...
#MY_REGISTRY=mirrorgcrio
MY_REGISTRY=

保存为shell脚本,然后执行。

3、升级Kubernetes集群

全新安装:

#指定IP地址,1.20.2版本:
sudo kubeadm init --kubernetes-version=v1.20.2 --apiserver-advertise-address=10.1.1.199 --pod-network-cidr=10.244.0.0/16

高可用安装(多master节点):

sudo kubeadm init --kubernetes-version=v1.20.2 
--apiserver-advertise-address=192.168.199.173 
--control-plane-endpoint=192.168.199.173:6443 
--pod-network-cidr=10.244.0.0/16 
--upload-certs

先查看一下需要升级的各个组件的版本。

使用****kubeadm upgrade plan ,输出的版本升级信息如下:

Components that must be upgraded manually after you have upgraded the control plane with 'kubeadm upgrade apply':
COMPONENT   CURRENT       AVAILABLE
Kubelet     1 x v1.20.0   v1.20.2
            8 x v1.20.0   v1.20.2

Upgrade to the latest version in the v1.20 series:

COMPONENT            CURRENT   AVAILABLE
API Server           v1.20.0   v1.20.2
Controller Manager   v1.20.0   v1.20.2
Scheduler            v1.20.0   v1.20.2
Kube Proxy           v1.20.0   v1.20.2
CoreDNS              1.7.0     1.7.0
Etcd                 3.4.13-0     3.4.13-0

You can now apply the upgrade by executing the following command:

    kubeadm upgrade apply v1.20.2

确保上面的容器镜像已经下载(如果没有提前下载,可能被网络阻隔导致挂起),然后执行升级:

kubeadm upgrade apply v1.20.2

看到下面信息,就OK了。

[upgrade/successful] SUCCESS! Your cluster was upgraded to "v1.20.2". Enjoy!

然后,配置当前用户环境:

  mkdir -p $HOME/.kube
  sudo cp -i /etc/kubernetes/admin.conf $HOME/.kube/config
  sudo chown $(id -u):$(id -g) $HOME/.kube/config

就可以使用 kubectl version 来查看状态和 kubectl cluster-info 查看服务地址。

  • 如果服务没有起来,测试一下:
    • 查看服务版本,kubectl version
    • 查看集群信息,kubectl cluster-info
    • 查看服务状态,sudo systemctl status kubelet
    • 查看服务日志,journalctl -xefu kubelet

4、工作节点的升级

每个工作节点需要拉取上面对应版本的镜像,以及安装kubelet的对应版本。

检查版本:

~$ kubectl version

查看Pod信息:

kubectl get pod --all-namespaces

完成。

⚠️注意:1.17后版本,如果使用kubeadm安装为高可用模式,所有master节点都可以被升为最新版本(需要提前把k8s的容器镜像放到节点上去)。

更多参考:

点赞
收藏
评论区
推荐文章
秃头王路飞 秃头王路飞
2个月前
webpack5手撸vue2脚手架
webpack5手撸vue相信工作个12年的小伙伴们在面试的时候多多少少怕被问到关于webpack方面的知识,本菜鸟最近闲来无事,就尝试了手撸了下vue2的脚手架,第一次发帖实在是没有经验,望海涵。 language JavaScript "name": "vuecliversion2", "version": "1.0.0", "desc
技术小男生 技术小男生
2个月前
linux环境jdk环境变量配置
1:编辑系统配置文件vi /etc/profile2:按字母键i进入编辑模式,在最底部添加内容: JAVAHOME/opt/jdk1.8.0152 CLASSPATH.:$JAVAHOME/lib/dt.jar:$JAVAHOME/lib/tools.jar PATH$JAVAHOME/bin:$PATH3:生效配置
光头强的博客 光头强的博客
2个月前
Java面向对象试题
1、 请创建一个Animal动物类,要求有方法eat()方法,方法输出一条语句“吃东西”。 创建一个接口A,接口里有一个抽象方法fly()。创建一个Bird类继承Animal类并实现 接口A里的方法输出一条有语句“鸟儿飞翔”,重写eat()方法输出一条语句“鸟儿 吃虫”。在Test类中向上转型创建b对象,调用eat方法。然后向下转型调用eat()方
刚刚好 刚刚好
2个月前
css问题
1、 在IOS中图片不显示(给图片加了圆角或者img没有父级) <div<img src""/</div div {width: 20px; height: 20px; borderradius: 20px; overflow: h
blmius blmius
1年前
MySQL:[Err] 1292 - Incorrect datetime value: ‘0000-00-00 00:00:00‘ for column ‘CREATE_TIME‘ at row 1
文章目录 问题 用navicat导入数据时,报错: 原因这是因为当前的MySQL不支持datetime为0的情况。 解决修改sql\mode: sql\mode:SQL Mode定义了MySQL应支持的SQL语法、数据校验等,这样可以更容易地在不同的环境中使用MySQL。 全局s
小森森 小森森
2个月前
校园表白墙微信小程序V1.0 SayLove -基于微信云开发-一键快速搭建,开箱即用
后续会继续更新,敬请期待2.0全新版本 欢迎添加左边的微信一起探讨!项目地址:](https://www.aliyun.com/activity/daily/bestoffer?userCodesskuuw5n) \2. Bug修复更新日历 2. 情侣脸功能大家不要使用了,现在阿里云的接口已经要收费了(土豪请随意), \ \ 和 注意
晴空闲云 晴空闲云
2个月前
css中box-sizing解放盒子实际宽高计算
我们知道传统的盒子模型,如果增加内边距padding和边框border,那么会撑大整个盒子,造成盒子的宽度不好计算,在实务中特别不方便。boxsizing可以设置盒模型的方式,可以很好的设置固定宽高的盒模型。 盒子宽高计算假如我们设置如下盒子:宽度和高度均为200px,那么这会这个盒子实际的宽高就都是200px。但是当我们设置这个盒子的边框和内间距的时候,那
艾木酱 艾木酱
1个月前
快速入门|使用MemFire Cloud构建React Native应用程序
> MemFire Cloud是一款提供云数据库,用户可以创建云数据库,并对数据库进行管理,还可以对数据库进行备份操作。它还提供后端即服务,用户可以在1分钟内新建一个应用,使用自动生成的API和SDK,访问云数据库、对象存储、用户认证与授权等功能,可专
Stella981 Stella981
1年前
KVM调整cpu和内存
一.修改kvm虚拟机的配置 1、virsh edit centos7 找到“memory”和“vcpu”标签,将 <name>centos7</name> <uuid>2220a6d1-a36a-4fbb-8523-e078b3dfe795</uuid>
helloworld_28799839 helloworld_28799839
2个月前
常用知识整理
# Javascript ## 判断对象是否为空 ```js Object.keys(myObject).length === 0 ``` ## 经常使用的三元运算 > 我们经常遇到处理表格列状态字段如 `status` 的时候可以用到 ``` vue